package org.jeecg.modules.projectManagement.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.projectManagement.entity.FdBioanalysisSampleMilestonesCompletedNumber;
import org.jeecg.modules.projectManagement.service.IFdBioanalysisSampleMilestonesCompletedNumberService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

/**
 * @Title: Controller
 * @Description: 生物分析样本里程碑当前完成数量
 * @author： jeecg-boot
 * @date： 2019-06-04
 * @version： V1.0
 */
@RestController
@RequestMapping("/projectManagement/fdBioanalysisSampleMilestonesCompletedNumber")
@Slf4j
public class FdBioanalysisSampleMilestonesCompletedNumberController {
    @Autowired
    private IFdBioanalysisSampleMilestonesCompletedNumberService fdBioanalysisSampleMilestonesCompletedNumberService;

    /**
     * 分页列表查询
     *
     * @param fdBioanalysisSampleMilestonesCompletedNumber
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @GetMapping(value = "/list")
    public Result<IPage<FdBioanalysisSampleMilestonesCompletedNumber>> queryPageList(FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumber,
                                                                                     @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                                                     @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                                                     HttpServletRequest req) {
        Result<IPage<FdBioanalysisSampleMilestonesCompletedNumber>> result = new Result<IPage<FdBioanalysisSampleMilestonesCompletedNumber>>();
        QueryWrapper<FdBioanalysisSampleMilestonesCompletedNumber> queryWrapper = QueryGenerator.initQueryWrapper(fdBioanalysisSampleMilestonesCompletedNumber, req.getParameterMap());
        queryWrapper.lambda().orderByAsc(FdBioanalysisSampleMilestonesCompletedNumber::getSort);
        Page<FdBioanalysisSampleMilestonesCompletedNumber> page = new Page<FdBioanalysisSampleMilestonesCompletedNumber>(pageNo, pageSize);
        queryWrapper.lambda().eq(FdBioanalysisSampleMilestonesCompletedNumber::getDelFlag,"0");
        queryWrapper.lambda().orderByAsc(FdBioanalysisSampleMilestonesCompletedNumber::getCreateTime);
        IPage<FdBioanalysisSampleMilestonesCompletedNumber> pageList = fdBioanalysisSampleMilestonesCompletedNumberService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param fdBioanalysisSampleMilestonesCompletedNumber
     * @return
     */
    @PostMapping(value = "/add")
    public Result<FdBioanalysisSampleMilestonesCompletedNumber> add(@RequestBody FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumber) {
        Result<FdBioanalysisSampleMilestonesCompletedNumber> result = new Result<FdBioanalysisSampleMilestonesCompletedNumber>();
        try {
            fdBioanalysisSampleMilestonesCompletedNumberService.save(fdBioanalysisSampleMilestonesCompletedNumber);
            result.success("添加成功！");
        } catch (Exception e) {
            e.printStackTrace();
            log.info(e.getMessage());
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param fdBioanalysisSampleMilestonesCompletedNumber
     * @return
     */
    @PutMapping(value = "/edit")
    public Result<FdBioanalysisSampleMilestonesCompletedNumber> edit(@RequestBody FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumber) {
        Result<FdBioanalysisSampleMilestonesCompletedNumber> result = new Result<FdBioanalysisSampleMilestonesCompletedNumber>();
        FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumberEntity = fdBioanalysisSampleMilestonesCompletedNumberService.getById(fdBioanalysisSampleMilestonesCompletedNumber.getId());
        if (fdBioanalysisSampleMilestonesCompletedNumberEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = fdBioanalysisSampleMilestonesCompletedNumberService.updateById(fdBioanalysisSampleMilestonesCompletedNumber);
            //TODO 返回false说明什么？
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @DeleteMapping(value = "/delete")
    public Result<FdBioanalysisSampleMilestonesCompletedNumber> delete(@RequestParam(name = "id", required = true) String id) {
        Result<FdBioanalysisSampleMilestonesCompletedNumber> result = new Result<FdBioanalysisSampleMilestonesCompletedNumber>();
        FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumber = fdBioanalysisSampleMilestonesCompletedNumberService.getById(id);
        if (fdBioanalysisSampleMilestonesCompletedNumber == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = fdBioanalysisSampleMilestonesCompletedNumberService.removeById(id);
            if (ok) {
                result.success("删除成功!");
            }
        }

        return result;
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @DeleteMapping(value = "/deleteBatch")
    public Result<FdBioanalysisSampleMilestonesCompletedNumber> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<FdBioanalysisSampleMilestonesCompletedNumber> result = new Result<FdBioanalysisSampleMilestonesCompletedNumber>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.fdBioanalysisSampleMilestonesCompletedNumberService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @GetMapping(value = "/queryById")
    public Result<FdBioanalysisSampleMilestonesCompletedNumber> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<FdBioanalysisSampleMilestonesCompletedNumber> result = new Result<FdBioanalysisSampleMilestonesCompletedNumber>();
        FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumber = fdBioanalysisSampleMilestonesCompletedNumberService.getById(id);
        if (fdBioanalysisSampleMilestonesCompletedNumber == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(fdBioanalysisSampleMilestonesCompletedNumber);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<FdBioanalysisSampleMilestonesCompletedNumber> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumber = JSON.parseObject(deString, FdBioanalysisSampleMilestonesCompletedNumber.class);
                queryWrapper = QueryGenerator.initQueryWrapper(fdBioanalysisSampleMilestonesCompletedNumber, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<FdBioanalysisSampleMilestonesCompletedNumber> pageList = fdBioanalysisSampleMilestonesCompletedNumberService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "生物分析样本里程碑当前完成数量列表");
        mv.addObject(NormalExcelConstants.CLASS, FdBioanalysisSampleMilestonesCompletedNumber.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("生物分析样本里程碑当前完成数量列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();// 获取上传文件对象
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<FdBioanalysisSampleMilestonesCompletedNumber> listFdBioanalysisSampleMilestonesCompletedNumbers = ExcelImportUtil.importExcel(file.getInputStream(), FdBioanalysisSampleMilestonesCompletedNumber.class, params);
                for (FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumberExcel : listFdBioanalysisSampleMilestonesCompletedNumbers) {
                    fdBioanalysisSampleMilestonesCompletedNumberService.save(fdBioanalysisSampleMilestonesCompletedNumberExcel);
                }
                return Result.ok("文件导入成功！数据行数：" + listFdBioanalysisSampleMilestonesCompletedNumbers.size());
            } catch (Exception e) {
                log.error(e.getMessage());
                return Result.error("文件导入失败！");
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

    @PostMapping(value = "/saveBach")
    public Result saveBach(@RequestBody List<FdBioanalysisSampleMilestonesCompletedNumber> list) {
        Result result = new Result();
        try {
            //获取里程碑id
            String milesId = "";
            //清除子表完成数量数据id
            for (FdBioanalysisSampleMilestonesCompletedNumber fdBioanalysisSampleMilestonesCompletedNumber : list) {
                fdBioanalysisSampleMilestonesCompletedNumber.setId("");
                milesId = fdBioanalysisSampleMilestonesCompletedNumber.getPkBioanalysisSampleMilestones();
            }
            //删除原来的完成数量数据
            if (milesId != null) {
                LambdaQueryWrapper<FdBioanalysisSampleMilestonesCompletedNumber> queryWrapper2 = new LambdaQueryWrapper<>();
                queryWrapper2.eq(FdBioanalysisSampleMilestonesCompletedNumber::getPkBioanalysisSampleMilestones, milesId);
                fdBioanalysisSampleMilestonesCompletedNumberService.remove(queryWrapper2);
            }
            //批量保存完成数量数据
            fdBioanalysisSampleMilestonesCompletedNumberService.saveBatch(list);
            result.setSuccess(true);
        } catch (Exception e) {
            e.printStackTrace();
            result.error500("保存失败" + e.getMessage());
        }
        return result;
    }

    /***
     * @Title:完成数量填报月份与等级月份不相等数据报表
            * @Description:TODO
            * @param [startDate, endDate]
            * @return org.jeecg.common.api.vo.Result<java.util.List<org.jeecg.modules.projectManagement.entity.FdBioanalysisSampleMilestonesCompletedNumber>>
            * @exception 
            * @author 陈创
            * @date 2019/9/10 17:50
            * @updatehistory:
     *   2019/9/10 17:50 新增
            */
    @GetMapping(value = "/getMonthlyDiscrepancyReport")
    @RequiresPermissions("url:bioanalysis-monthly-discrepancy-report:view")
    public Result<List<FdBioanalysisSampleMilestonesCompletedNumber>> getMonthlyDiscrepancyReport(String startDate, String endDate){
        Result<List<FdBioanalysisSampleMilestonesCompletedNumber>> result=new Result<>();
        try {
            List<FdBioanalysisSampleMilestonesCompletedNumber> fdBioanalysisSampleMilestonesCompletedNumberList=fdBioanalysisSampleMilestonesCompletedNumberService.getMonthlyDiscrepancyReport(startDate,endDate);
            result.setResult(fdBioanalysisSampleMilestonesCompletedNumberList);
        } catch (Exception e) {
            e.printStackTrace();
            result.error500("操作失败："+e.getMessage());
        }
        return result;
    }

    /***
     * @Title:批量修改完成数量
            * @Description:TODO
            * @param [numberList]
            * @return org.jeecg.common.api.vo.Result
            * @exception 
            * @author 陈创
            * @date 2019/11/20 18:16
            * @updatehistory:
     *   2019/11/20 18:16 新增
            */
    @PostMapping(value = "/completedNumberBatch")
    public Result completedNumberBatch(@RequestBody List<FdBioanalysisSampleMilestonesCompletedNumber> numberList){
        Result result=new Result();
        try {
            fdBioanalysisSampleMilestonesCompletedNumberService.updateCompletedNumberBatch(numberList);
            result.setSuccess(true);
        } catch (Exception e) {
            e.printStackTrace();
            result.error500("操作失败:"+e.getMessage());
        }
        return result;
    }

}
